import 'dart:async';

import 'package:flutter/services.dart';

class Mrzflutterplugin {
  static const MethodChannel _channel = const MethodChannel('mrzflutterplugin');

  // Initiates the scanner view
  static Future<String> get startScanner async {
    final String scannerResult = await _channel.invokeMethod("startScanner");
    return scannerResult;
  }

  // Register with the licence key provided to remove the asterisks (*) from the result.
  static void registerWithLicenceKey(String licenceKey) {
    _channel.invokeMethod("registerWithLicenceKey", licenceKey);
  }

  // Specify whether the scanner should detect and return result for passports.
  static void setPassportActive(bool active) {
    _channel.invokeMethod("setPassportActive", active);
  }

  // Specify whether the scanner should detect and return result for IDs.
  static void setIDActive(bool active) {
    _channel.invokeMethod("setIDActive", active);
  }
  // Specify whether the scanner should detect and return result for Visas.
  static void setVisaActive(bool active) {
    _channel.invokeMethod("setVisaActive", active);
  }

  // Set the date format in which the parsed dates are formatted.
  static void setDateFormat(String dateFormat) {
    _channel.invokeMethod("setDateFormat", dateFormat);
  }

  // Trigger an image picker.
  static Future<String> get scanFromGallery async {
    final String scannerResult = await _channel.invokeMethod("scanFromGallery");
    return scannerResult;
  }

  // Returns the current SDK Version
  static Future<String> get getSdkVersion async {
    final String sdkVersion = await _channel.invokeMethod("getSdkVersion");
    return sdkVersion;
  }
}
